#ifndef BPPDEF_H
#define BPPDEF_H

#include <limits.h>
#include <stddef.h>
//#define EMULATE_I64
#ifndef WINCE
  #ifdef _WIN32_WCE
    #define WINCE
  #endif
#endif

#ifdef _MSC_VER
  #if _MSC_VER <= 800 
     typedef int bool;
     #define true 1
     #define false 0
     #define __NOSTL__
     #define NOCPPEXCEPTION 
     #define asm __asm
  #endif
#endif
#ifndef NOASM
  #ifdef WINCE
     #define NOASM
  #endif
  #ifdef GCC
     #define NOASM
 //    #define __NOSTL__
  #endif
  #ifdef _WIN64
    #define NOASM
	#ifndef WIN32
	  #define WIN32
	#endif
  #endif
#endif
#ifdef WINCE
// on Windows CE WIN32 must be defined too
#ifndef WIN32
  #define WIN32
#endif
	 typedef int ptrdiff_t;
	#define EDOM 33
	#define ERANGE 34
	#undef STRSAFE_NO_DEPRECATE
	#define DEPRECATE_SUPPORTED  
	// not all versions of WinCE SDK support C++ exceptions
  #define NOCPPEXCEPTION
  // CRT library for WinCE doesn't support conio.h functions
  #define NOCONIO
  // not all versions of WinCE SDK support STL
  #define __NOSTL__
#endif

#ifdef WIN32
   #ifndef _CONSOLE
      // console io is useable only in console applications
      #ifndef NOCONIO
         #define NOCONIO
      #endif
   #endif
  #include <windows.h>
  #ifdef BUILD_BPPLIB
    #define BPPLIB_DLLEXP __declspec(dllexport)
  #else
    #define BPPLIB_DLLEXP __declspec(dllimport)
  #endif
  #define BPPAPI WINAPI
#else // no WIN32
   #define BPPLIB_DLLEXP
   #define BPPAPI
#endif 
#ifndef LLONG_MAX 
    // Use int64 emulation if needed
	#ifndef EMULATE_I64
		#ifndef  WINCE
			   #define EMULATE_I64
		#endif
	#endif
#endif
#include <bpptchar.h>

#ifndef _UNICODE
   typedef char BppChar;
   typedef unsigned char BppUChar;
#else
   typedef wchar_t BppChar;
   typedef unsigned short BppUChar;
#endif



#ifdef __TURBOC__

#if (__TURBOC__ < 0x0450)
#ifndef __OLDCPP__
#define __OLDCPP__
#endif
#endif

  enum bool
  {
    false = 0,
	 true = 1
  };

#endif
#ifdef __OLDCPP__

#define NOCPPEXCEPTION

#else
  // Check for 64 bit Platform
	#if ((SIZE_MAX > UINT_MAX) && (USHRT_MAX < UINT_MAX))
	#define BPP_I64
	#endif
#endif
// Define build specific suffix
#ifdef BPP_I64
#define __PLFEXT _T("_64")
#else
#define __PLFEXT _T("")
#endif

#ifdef _UNICODE
  #ifdef _DEBUG
    #define BPP_DLLWILD (L"ud" __PLFEXT)
  #else
    #define BPP_DLLWILD (L"u" __PLFEXT)
  #endif
#else
  #ifdef _DEBUG
    #define BPP_DLLWILD ("d" __PLFEXT)
  #else
    #define BPP_DLLWILD __PLFEXT
  #endif
#endif

   typedef unsigned char BppByte;
   typedef char BppSByte;
   typedef unsigned short BppWord;
   typedef short BppShort;
   typedef unsigned short BppUShort;
#if (INT_MAX == SHRT_MAX)
  typedef long BppInt;
  typedef unsigned long BppUInt;
  typedef unsigned BppNWord;
  typedef BppInt BppIntPtr;
#else
  typedef int BppInt;
  typedef unsigned int BppUInt;
  typedef BppUInt BppNWord; 
  typedef ptrdiff_t BppIntPtr;
#endif
  typedef BppUInt BppDWord;
#ifdef GCC
  #define __int64 long long
#endif
#ifdef EMULATE_I64
    #include <int64.h> 
	typedef Int64 BppLong;
	typedef UInt64 BppULong;
#else
  typedef __int64 BppLong;
  typedef unsigned __int64 BppULong;
  typedef __int64 _Int64;
  typedef unsigned __int64 _UInt64;
#endif

class BppValue;
class ValPtr;
class BppVirtualMachine;
class BppObject;

enum BP_ERR_CODES
{
   BP_ERR_NOMEM = 1
};

enum _BppObjectNotifyType
{
   BPP_OBJ_NONE = 0,
   BPP_OBJ_CREATE,
   BPP_OBJ_COPY,
   BPP_OBJ_DELETE,
   BPP_OBJ_BEFORESERIALIZE,
   BPP_OBJ_AFTERDESERIALIZE
};
typedef enum _BppObjectNotifyType BppObjectNotifyType;

#ifdef NOASM
typedef BppIntPtr (BPPAPI *DLLFUNC0)();
typedef BppIntPtr (BPPAPI *DLLFUNC1)(BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC2)(BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC3)(BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC4)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC5)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC6)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC7)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC8)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC9)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC10)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC11)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC12)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC13)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC14)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC15)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
typedef BppIntPtr (BPPAPI *DLLFUNC16)(BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr,BppIntPtr);
#endif

typedef bool (*BPPUSERFUNC) (BppVirtualMachine* vm, int argc, ValPtr& sp);
#define BPPMOVE(V) (V)
#ifdef __cplusplus
#ifdef __cpp_rvalue_references 
  #define CPP11
  #include <utility>
  #undef BPPMOVE
  #define BPPMOVE(V) std::move((V))
#endif
typedef void (BPPAPI * BppObjNotifyProc)(BppVirtualMachine* vm, BppObject* obj, void** nativeObject, BppObjectNotifyType reason);
typedef bool (BPPAPI *BppDbgWaitProc)();
typedef bool (BPPAPI *BppBreakRequestProc)();
typedef bool (BPPAPI *BppLineChangedProc)(const char* srcName, BppInt lineNumber);
typedef void (BPPAPI *BppRegisterNativeModuleFunc)(BppVirtualMachine* vm);
typedef void (BPPAPI *BppPrinterCallback) (const char* text);
typedef int (BPPAPI *BppCharInputCallback) ();
typedef const char*  (BPPAPI *BppStringInputCallback) ();
#include <locale.h>
struct _CLocale {
      char* _old;
      _CLocale() { _old = setlocale(LC_ALL, "C"); } 
      ~_CLocale() { setlocale(LC_ALL, _old); } 
};
#define C_LOCALE _CLocale __cLocale

#else
typedef void (BPPAPI *BppObjNotifyProc)void* pVm, void* pObj, void** nativeObject, BppObjectNotifyType reason);
typedef int (BPPAPI *BppDbgWaitProc)();
typedef int (BPPAPI *BppBreakRequestProc)();
typedef int (BPPAPI *BppLineChangedProc)(char* srcName, BppInt lineNumber);
typedef void (BPPAPI *BppRegisterNativeModuleFunc)(void* pVm);
typedef void (BPPAPI *BppPrinterCallback) (char* text);
#endif
#ifdef __linux__
typedef void* HDLL;
typedef void* HMODULE;
#define LoadLibrary(lpFileName) dlopen(lpFileName, RTLD_NOW)
#define FreeLibrary(hModule) dlclose(hModule)
#define GetProcAddress(hModule,lpProcName) dlsym(hModule,lpProcName)
#endif
#endif // BPPDEF_H
