#include "rational.h"
#include "int64.h"
#include <stdio.h>
#include <math.h>

class IManagedVoid
{
public:
	virtual ~IManagedVoid()
	{
	}
	virtual operator void*() const = 0;
};

template<class T> class ManagedVoid : public IManagedVoid
{
public:
	ManagedVoid(T* ptr) : _ptr(ptr) {}
	virtual ~ManagedVoid() 
	{ 
		delete _ptr; 
	}
	virtual operator void*() const  { return _ptr; }
private:
	T* _ptr;
};

int main(int, char**)
{
	{
		IManagedVoid* pv = new ManagedVoid<int>(new int(1));
		delete pv;
	}
	rational klein="0.0345";
	rational pi=  "355/113";
	rational dpi = 3.1415927E2;
	rational mpi = "-3.1415927";
	rational a = (rint)1;
	rational b(3,4);
    rational acht = (rint)8;
	printf("rational klein(0.0345)\n");
    printf("(const char*)klein = %s\n",(const char*)klein);
    printf("klein.fltStr(8) = %s\n",klein.fltStr(8));
	printf("rational pi(\"355/113\")\n");
    printf("(const char*)pi = %s\n",(const char*)pi);
    printf("pi.fltStr(8) = %s\n",pi.fltStr(8));
	printf("rational dpi(3.1415927e2)\n");
    printf("(const char*)dpi = %s\n",(const char*)dpi);
    printf("dpi.fltStr(8) = %s\n",dpi.fltStr(8));
	printf("rational mpi(\"-3.1415927\")\n");
    printf("(const char*)mpi = %s\n",(const char*)mpi);
    printf("mpi.fltStr(8) = %s\n",mpi.fltStr(8));
     printf("(1+(3/4))/(3/4) = %s\n",(const char*)((a+b)/b));
    printf("(1+(3/4))/(3/4) = %s\n",((a+b)/b).fltStr(8));
    printf("sqrt(8) = %s\n",(acht.sqrt()).fltStr(8));
    printf("acht = %s\n",(acht.sqrt()*acht.sqrt()).fltStr(8));

	printf("sqrt(3/4) = %s\n",(b.sqrt()).fltStr(8));
    printf("sqrt(3/4) = %s\n",(const char*)(b.sqrt()));
    printf("sqrt(3/4) = %s\n",(const char*)(b.sqrt().reduce()));
    printf("3/4 = %s\n",b.fltStr(8));
	rational sqr = b.sqrt()*b.sqrt();
	rational sqr2 = sqr.reduce();
    printf("(sqrt(3/4))^2 = %s\n",sqr.fltStr(8));
    printf("(sqrt(3/4))^2 = %s\n",(const char*)sqr);
    printf("(sqrt(3/4))^2 = %s\n",(const char*)sqr2);
	rational r8 = acht.root(3);
    printf("(root3(8) = %s\n",(const char*)r8);
    printf("(root3(8) = %s\n",r8.fltStr());
    printf("acht = %s\n",r8.pow_n(3).fltStr());
	rational r48 = acht.root(4);
    printf("(root4(8) = %s\n",(const char*)r48);
    printf("(root4(8) = %s\n",r48.fltStr());
    printf("acht = %s\n",r48.pow_n(4).fltStr());

	char buf[66];
	Int64 i64(pow(2.0,32));
	__int64 r = i64;
	i64.toa(buf);
	i64.toa(buf,2);
	r = i64;
	i64 /= Int64(-2L);
	i64.toa(buf);
	r = i64;
	i64 *= Int64(2L);

	i64.toa(buf);
	r = i64;
	i64 = 25;
	i64 = i64 * Int64(5L);
	i64 *= Int64(2L);
}