
#ifndef _PLATFORM_WIN32_H
#define _PLATFORM_WIN32_H

#include <windows.h>

extern void* RexWin32Malloc(size_t size);
extern void* RexWin32Realloc(void *oldptr, size_t newsize);
extern void  RexWin32Free(void *ptr);
#define MALLOC(s)    RexWin32Malloc(s)
#define REALLOC(p,s) RexWin32Realloc((p),(s))
#define FREE(p)      RexWin32Free(p)

extern WORD RexWin32CharTypeA(char ch);
#define TOUPPER(c) (char)CharUpper((LPSTR)(char)(c))
#define ISALNUM(c)  (RexWin32CharTypeA((char)(c)) & (C1_ALPHA | C1_DIGIT))
#define ISALPHA(c)  (RexWin32CharTypeA((char)(c)) & C1_ALPHA)
#define ISBLANK(c)  (RexWin32CharTypeA((char)(c)) & C1_BLANK)
#define ISCNTRL(c)  (RexWin32CharTypeA((char)(c)) & C1_CNTRL)
#define ISDIGIT(c)  (RexWin32CharTypeA((char)(c)) & C1_DIGIT)
#define ISGRAPH(c) !(RexWin32CharTypeA((char)(c)) & (C1_CNTRL | C1_BLANK))
#define ISLOWER(c)  (RexWin32CharTypeA((char)(c)) & C1_LOWER)
#define ISPRINT(c) !(RexWin32CharTypeA((char)(c)) & C1_CNTRL)
#define ISPUNCT(c)  (RexWin32CharTypeA((char)(c)) & C1_PUNCT)
#define ISSPACE(c) ISBLANK(c)
#define ISUPPER(c)  (RexWin32CharTypeA((char)(c)) & C1_UPPER)
#define ISXDIGIT(c) (RexWin32CharTypeA((char)(c)) & C1_XDIGIT)

#ifdef DEBUG
#ifdef DEBUGPRINT
#include <stdio.h>
#define DPRINTF(x) printf x
#else
#define DPRINTF(x)
#endif
#include <assert.h>
#define ASSERT(x) assert(x)
#else
#define DPRINTF(x)
#define ASSERT(x)
#endif

#include <string.h>
#define MEMCPY(dest,src,len) CopyMemory((dest),(src),(len))
#define MEMSET(dest,ch,len)  FillMemory((dest),(len),(ch))


#endif
