#include "trex.h"
#include <stdio.h>
#include <string.h>


#ifdef _UNICODE
#define trex_sprintf swprintf
#else
#define trex_sprintf sprintf_s
#endif
#if defined(__BORLANDC__) || defined(__TURBOC__)
#define sprintf_s(buf,len,fmt,v) sprintf(buf,fmt,v)
#define FMT _TREXC("[%%ld]%%.%lds\n")
#else
#define FMT _TREXC("[%%d]%%.%ds\n")
#endif
int main(int argc, char* argv[])
{
	const TRexChar *begin,*end;
	TRexChar sTemp[200];
	const TRexChar* p = sTemp;
	const TRexChar *error = NULL;
	const TRexChar* pregex = _TREXC("^([0-9]+)([\\+\\-\\*/])(\\d+)+");
	struct TRex* x = trex_compile(pregex,&error);
	trex_printf(_TREXC("Regex: %s\n"),pregex);
	if(x) {
		TRexChar* pexpr = _TREXC("1+2*3/4-5");
	    trex_printf(_TREXC("Expr: %s\n"),pexpr);
		trex_sprintf(sTemp,200,pexpr,0);
		while(trex_search(x,p++,&begin,&end))
		{   
			TRexInt i,n = trex_getsubexpcount(x);
			TRexMatch match;
			 p = begin+1;
			for(i = 0; i < n; i++)
			{
				TRexChar t[200];
				trex_getsubexp(x,i,&match);
				trex_sprintf(t,200,(FMT),match.len);
				trex_printf(t,i,match.begin);
			}
			trex_printf(_TREXC("match! %d sub matches\n"),trex_getsubexpcount(x));
		}
	//	else {
	//		trex_printf(_TREXC("no match!\n"));
	//	}
		trex_free(x);
	}
	else {
		trex_printf(_TREXC("compilation error [%s]!\n"),error?error:_TREXC("undefined"));
	}
	return 0;
}
