/*
 * Copyright (c) 2001-2002 Daniel van Vugt <danv@users.sf.net>
 * This file is part of the Rex library.
 * See LICENSE.txt for license details.
 */

#include <windows.h>
#include <stddef.h>
#include "platform.h"


static HANDLE heap = NULL;


void*
RexWin32Malloc(size_t size)
{
	if (heap == NULL)
	{
		heap = GetProcessHeap();
	}
	return HeapAlloc(heap, 0, size);
}


void*
RexWin32Realloc(void *oldptr, size_t newsize)
{
	ASSERT(heap != NULL);
	return HeapReAlloc(heap, 0, oldptr, newsize);
}


void
RexWin32Free(void *ptr)
{
	ASSERT(heap != NULL);
	HeapFree(heap,0, ptr);
}


WORD
RexWin32CharTypeA(char ch)
{
	WORD result;
	if ( !GetStringTypeA(LOCALE_USER_DEFAULT, CT_CTYPE1, &ch, 1, &result) )
	{
		result = 0;
	}
	return result;
}


BOOL WINAPI
DllMain(HINSTANCE inst, DWORD reason, LPVOID reserved)
{
	return TRUE;
}
